diff --git a/lib/Mail/GnuPG.pm b/lib/Mail/GnuPG.pm
index 2541ccb..3c14f2b 100644
--- a/lib/Mail/GnuPG.pm
+++ b/lib/Mail/GnuPG.pm
@@ -165,7 +165,7 @@ sub decrypt {
   my $handles = GnuPG::Handles->new( stdin      => $input,
 				     stdout     => $output,
 				     stderr     => $error,
-				     passphrase => $passphrase_fh,
+				     $self->{use_agent} ? () : (passphrase => $passphrase_fh),
 				     status     => $status_fh,
 				   );
 
@@ -174,9 +174,9 @@ sub decrypt {
 
   die "NO PASSPHRASE" unless defined $passphrase_fh;
   my $read = _communicate([$output, $error, $status_fh],
-                        [$input, $passphrase_fh],
+                        [$input, $self->{use_agent} ? () : $passphrase_fh],
                         { $input => $ciphertext,
-                          $passphrase_fh => $self->{passphrase}}
+                          $self->{use_agent} ? () : ($passphrase_fh => $self->{passphrase})}
              );
 
   my @plaintext    = split(/^/m, $read->{$output});
